#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Sun Apr 23 10:30:50 2017

@author: poessel
"""

import matplotlib.pyplot as plt
import matplotlib.image as mpimg
import numpy as np

# Load test images with known number of circles:
img1=mpimg.imread('test1.png')
img5=mpimg.imread('test5.png')
img27=mpimg.imread('test27.png')

# This is the total pixel value sum R+G+B:
sum1=np.sum(img1)
sum5=np.sum(img5)
sum27=np.sum(img27)

# Tests:
print "Pixel sum for 1 circle: %d" % sum1
print "Pixel sum for 5 circles: %d" % sum5
print "Pixel sum for 27 circles: %d" % sum27

print "Cross-checks:"
print "%f circles detected on the 5-circle-image" % (sum5/sum1)
print "%f circles detected on the 27-circle-image"% (sum27/sum1)



#%%

# This is the non-extrapolated original version of the dots:
imgTotal=mpimg.imread('counting-dots.png')
# Careful, this has opacity information in it! This makes things a 
# little more complicated than for the simple test version:
height=imgTotal.shape[0]
width=imgTotal.shape[1]

# Calculate by summing up pixel values:
totalSum=0
for xx in range(width):
    for yy in range(height):
        totalSum += imgTotal[yy,xx,0]+imgTotal[yy,xx,1]+imgTotal[yy,xx,2]

# Check by calculating the same in an alternative, but faster way:
testTotalSum=np.sum(imgTotal) - 1.0*width*height

print "Simplified calc: %f vs. %f" % (totalSum,testTotalSum)
# Yes, this checks out!

# Attendance is total sum divided by pixel sum for a single circle:
attendance=totalSum/sum1
print "Attendance: %d people minimum" % attendance

#%%

# Extrapolated version:
imgwhite5=mpimg.imread('testwhite5.png')
imgwhite10=mpimg.imread('testwhite10.png')
imgwhite17=mpimg.imread('testwhite17.png')

# This is the extrapolated image (with extra dots added):
imgExtrapolated=mpimg.imread('counting-extrapolated.png')

# Tired of writing this out by hand; making this into a function:
def imgCount(thisImg):
    return np.sum(thisImg) - 1.0*thisImg.shape[0]*thisImg.shape[1]

sumWhite5=imgCount(imgwhite5)
sumWhite10=imgCount(imgwhite10)
sumWhite17=imgCount(imgwhite17)
sumWhite1=sumWhite5/5.0

print "Test:"
print "%f for the 10 circle image" % (sumWhite10/sumWhite1)
print "%f for the 17 circle image" % (sumWhite17/sumWhite1)

sumExtrapolated=imgCount(imgExtrapolated)
attendanceExtrapolated=sumExtrapolated/sumWhite1

print "Attendance: %f people extrapolated" % attendanceExtrapolated
# Probably some non-unity values for the alpha somewhere?

#%%

# Trying the hard way:
    

height2=imgExtrapolated.shape[0]
width2=imgExtrapolated.shape[1]

# Calculate by summing up pixel values:
totalExSum=0
for xx in range(width2):
    for yy in range(height2):
        totalExSum += imgExtrapolated[yy,xx,0]+imgExtrapolated[yy,xx,1]+imgExtrapolated[yy,xx,2]


print "Attendance: %f people extrapolated" % (totalExSum/sumWhite1)